#!/usr/bin/python
from string import split, find, letters

FIELD = 1
FORM = 3
TRUE = 1
FALSE = 0

def classify(line):
  words = split(line, '(')
  if len(words) != 2:
    return None, None, None
  function = split(words[0])
  function = function[-1]
  arguments = len(split(words[1], ',')) - 1
  while function[0] == '*':
    function = function[1:]
  if find(words[1], 'FORM') > -1:
    return FORM, function, arguments
  elif find(words[1], 'FIELD') > -1:
    return FIELD, function, arguments
  else:
    return None, None, None

def arglist(args):
  value = ''
  for each in xrange(args):
    value = value + ', ' + letters[each]
  return value + ')'

menus = []
items = []

go_on = FALSE
for line in open('ncurses/_form.i').readlines():
  if not go_on:
    if line == '/* functions */\n':
      go_on = TRUE
      continue
    else:
      continue
  id, function, arguments = classify(line)
  if id == FIELD:
    menus.append((function, arguments))
  elif id == FORM:
    items.append((function, arguments))

file = open('report', 'w')

file.write('######## FORM\n\n')
for item in items:
  args = arglist(item[1])
  file.write('def ' + item[0] + '(self' + args + ':\n')
  file.write('  return _menu.' + item[0] + '(self.FORM' + args + '\n\n')

file.write('######## FIELD\n\n')
for menu in menus:
  args = arglist(menu[1])
  file.write('def ' + menu[0] + '(self' + args + ':\n')
  file.write('  return _menu.' + menu[0] + '(self.FIELD' + args + '\n\n')


  
